DUP     ;( u -- u u , Duplicate cell on top of stack )
        push    eax
        tos     eax
        upsh    eax
        pop     eax
        ret
end DUP



_2DUP
        call    OVER
        call    OVER
        ret
end _2DUP



QDUP    ; ?DUP ( x -- x x , Duplicate x only if x != 0 )
        cmp     cell tosreg, 0
        jz      .end
        call    DUP
.end
        ret
end QDUP



OVER    ;( x1 x2 -- x1 x2 x1 )
        push    eax
        mov     eax, [ebp-2*CELLSIZE]
        upsh    eax
        pop     eax
        ret
end OVER



DROP    ;( u -- , Drop cell on top of stack )
        sub     ebp, CELLSIZE
        ret
end DROP



SWAP    ;( x1 x2 -- x2 x1 )
        push    eax
        push    edx
        mov     eax, [ebp-CELLSIZE]
        mov     edx, [ebp-2*CELLSIZE]
        mov     [ebp-CELLSIZE], edx
        mov     [ebp-2*CELLSIZE], eax
        pop     edx
        pop     eax
        ret
end SWAP



ROT     ;( x1 x2 x3 -- x2 x3 x1 )
        push    eax
        push    edx

        tos     edx                     ;DX = x3
        mov     eax, [ebp-3*CELLSIZE]   ;AX = x1
        mov     [ebp-CELLSIZE], eax     ;x3 = x1
        mov     eax, [ebp-2*CELLSIZE]   ;AX = x2
        mov     [ebp-3*CELLSIZE], eax   ;x1 = x2
        mov     [ebp-2*CELLSIZE], edx   ;x2 = x3

        pop     edx
        pop     eax
        ret
end ROT



TO_R            ; >R
; Compile-only
        upsh    cell .code
        call    HERE
        upsh    cell .end-.code
        call    DUP
        call    ALLOT
        call    _CMOVE
        ret
.code
        sub     ebp, CELLSIZE
        push    cell [ebp]
.end
end TO_R



R_FROM          ; R>
; Compile-only
        upsh    cell .code
        call    HERE
        upsh    cell .end-.code
        call    DUP
        call    ALLOT
        call    _CMOVE
        ret
.code
        pop     cell [ebp]
        add     ebp, CELLSIZE
.end
end R_FROM



R_FETCH         ; R@
; Compile-only
        upsh    cell .code
        call    HERE
        upsh    cell .end-.code
        call    DUP
        call    ALLOT
        call    _CMOVE
        ret
.code
        pop     cell [ebp]
        push    cell [ebp]
        add     ebp, CELLSIZE
.end
end R_FETCH



DEPTH   ; ( -- +n , get depth of stack, in # of cells )
        push    ecx

        mov     ecx, ebp
        shr     ecx, CELLSHIFT          ;CX = # of cells on stack
        upsh    ecx

        pop     ecx
        ret
end DEPTH



STACK_TRACE     ; .S
        push    ebx
        push    ecx

        call    CR
        upsh    cell '<'
        call    EMIT
        call    SPACE
        call    DEPTH
        call    PRINT
        upsh    cell '>'
        call    EMIT
        call    SPACE

        call    DEPTH
        upop    ecx
        cmp     ecx, 0
        jz      .end
        mov     ebx, 0
.loop
        mov     eax, [ss:ebx]
        upsh    eax
        call    PRINT
        add     ebx, CELLSIZE
        loop    .loop
.end
        call    CR

        pop     ecx
        pop     ebx
        ret
end STACK_TRACE


